//
// Prospecting.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct Prospecting: Codable, JSONEncodable, Hashable {

    public var id: Int?
    public var activeYN: Bool?
    public var bccMeYN: Bool?
    public var clientActivatedYN: Bool?
    public var conciergeNotificationsYN: Bool?
    public var conciergeYN: Bool?
    public var contactKeyNumeric: Double?
    public var ownerMemberKeyNumeric: Double?
    public var prospectingKeyNumeric: Double?
    public var savedSearchKeyNumeric: Double?
    public var bccEmailList: String?
    public var ccEmailList: String?
    public var contactKey: String?
    public var displayTemplateID: String?
    public var messageNew: String?
    public var messageRevise: String?
    public var messageUpdate: String?
    public var ownerMemberID: String?
    public var ownerMemberKey: String?
    public var prospectingKey: String?
    public var savedSearchKey: String?
    public var subject: String?
    public var toEmailList: String?
    public var dailySchedule: [String]?
    public var languages: String?
    public var reasonActiveOrDisabled: String?
    public var scheduleType: String?
    public var lastNewChangedTimestamp: Date?
    public var lastViewedTimestamp: Date?
    public var modificationTimestamp: Date?
    public var nextSendTimestamp: Date?
    public var contact: Contacts?
    public var ownerMember: Member?
    public var savedSearch: SavedSearch?

    public init(id: Int? = nil, activeYN: Bool? = nil, bccMeYN: Bool? = nil, clientActivatedYN: Bool? = nil, conciergeNotificationsYN: Bool? = nil, conciergeYN: Bool? = nil, contactKeyNumeric: Double? = nil, ownerMemberKeyNumeric: Double? = nil, prospectingKeyNumeric: Double? = nil, savedSearchKeyNumeric: Double? = nil, bccEmailList: String? = nil, ccEmailList: String? = nil, contactKey: String? = nil, displayTemplateID: String? = nil, messageNew: String? = nil, messageRevise: String? = nil, messageUpdate: String? = nil, ownerMemberID: String? = nil, ownerMemberKey: String? = nil, prospectingKey: String? = nil, savedSearchKey: String? = nil, subject: String? = nil, toEmailList: String? = nil, dailySchedule: [String]? = nil, languages: String? = nil, reasonActiveOrDisabled: String? = nil, scheduleType: String? = nil, lastNewChangedTimestamp: Date? = nil, lastViewedTimestamp: Date? = nil, modificationTimestamp: Date? = nil, nextSendTimestamp: Date? = nil, contact: Contacts? = nil, ownerMember: Member? = nil, savedSearch: SavedSearch? = nil) {
        self.id = id
        self.activeYN = activeYN
        self.bccMeYN = bccMeYN
        self.clientActivatedYN = clientActivatedYN
        self.conciergeNotificationsYN = conciergeNotificationsYN
        self.conciergeYN = conciergeYN
        self.contactKeyNumeric = contactKeyNumeric
        self.ownerMemberKeyNumeric = ownerMemberKeyNumeric
        self.prospectingKeyNumeric = prospectingKeyNumeric
        self.savedSearchKeyNumeric = savedSearchKeyNumeric
        self.bccEmailList = bccEmailList
        self.ccEmailList = ccEmailList
        self.contactKey = contactKey
        self.displayTemplateID = displayTemplateID
        self.messageNew = messageNew
        self.messageRevise = messageRevise
        self.messageUpdate = messageUpdate
        self.ownerMemberID = ownerMemberID
        self.ownerMemberKey = ownerMemberKey
        self.prospectingKey = prospectingKey
        self.savedSearchKey = savedSearchKey
        self.subject = subject
        self.toEmailList = toEmailList
        self.dailySchedule = dailySchedule
        self.languages = languages
        self.reasonActiveOrDisabled = reasonActiveOrDisabled
        self.scheduleType = scheduleType
        self.lastNewChangedTimestamp = lastNewChangedTimestamp
        self.lastViewedTimestamp = lastViewedTimestamp
        self.modificationTimestamp = modificationTimestamp
        self.nextSendTimestamp = nextSendTimestamp
        self.contact = contact
        self.ownerMember = ownerMember
        self.savedSearch = savedSearch
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case id
        case activeYN = "ActiveYN"
        case bccMeYN = "BccMeYN"
        case clientActivatedYN = "ClientActivatedYN"
        case conciergeNotificationsYN = "ConciergeNotificationsYN"
        case conciergeYN = "ConciergeYN"
        case contactKeyNumeric = "ContactKeyNumeric"
        case ownerMemberKeyNumeric = "OwnerMemberKeyNumeric"
        case prospectingKeyNumeric = "ProspectingKeyNumeric"
        case savedSearchKeyNumeric = "SavedSearchKeyNumeric"
        case bccEmailList = "BccEmailList"
        case ccEmailList = "CcEmailList"
        case contactKey = "ContactKey"
        case displayTemplateID = "DisplayTemplateID"
        case messageNew = "MessageNew"
        case messageRevise = "MessageRevise"
        case messageUpdate = "MessageUpdate"
        case ownerMemberID = "OwnerMemberID"
        case ownerMemberKey = "OwnerMemberKey"
        case prospectingKey = "ProspectingKey"
        case savedSearchKey = "SavedSearchKey"
        case subject = "Subject"
        case toEmailList = "ToEmailList"
        case dailySchedule = "DailySchedule"
        case languages = "Languages"
        case reasonActiveOrDisabled = "ReasonActiveOrDisabled"
        case scheduleType = "ScheduleType"
        case lastNewChangedTimestamp = "LastNewChangedTimestamp"
        case lastViewedTimestamp = "LastViewedTimestamp"
        case modificationTimestamp = "ModificationTimestamp"
        case nextSendTimestamp = "NextSendTimestamp"
        case contact = "Contact"
        case ownerMember = "OwnerMember"
        case savedSearch = "SavedSearch"
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(id, forKey: .id)
        try container.encodeIfPresent(activeYN, forKey: .activeYN)
        try container.encodeIfPresent(bccMeYN, forKey: .bccMeYN)
        try container.encodeIfPresent(clientActivatedYN, forKey: .clientActivatedYN)
        try container.encodeIfPresent(conciergeNotificationsYN, forKey: .conciergeNotificationsYN)
        try container.encodeIfPresent(conciergeYN, forKey: .conciergeYN)
        try container.encodeIfPresent(contactKeyNumeric, forKey: .contactKeyNumeric)
        try container.encodeIfPresent(ownerMemberKeyNumeric, forKey: .ownerMemberKeyNumeric)
        try container.encodeIfPresent(prospectingKeyNumeric, forKey: .prospectingKeyNumeric)
        try container.encodeIfPresent(savedSearchKeyNumeric, forKey: .savedSearchKeyNumeric)
        try container.encodeIfPresent(bccEmailList, forKey: .bccEmailList)
        try container.encodeIfPresent(ccEmailList, forKey: .ccEmailList)
        try container.encodeIfPresent(contactKey, forKey: .contactKey)
        try container.encodeIfPresent(displayTemplateID, forKey: .displayTemplateID)
        try container.encodeIfPresent(messageNew, forKey: .messageNew)
        try container.encodeIfPresent(messageRevise, forKey: .messageRevise)
        try container.encodeIfPresent(messageUpdate, forKey: .messageUpdate)
        try container.encodeIfPresent(ownerMemberID, forKey: .ownerMemberID)
        try container.encodeIfPresent(ownerMemberKey, forKey: .ownerMemberKey)
        try container.encodeIfPresent(prospectingKey, forKey: .prospectingKey)
        try container.encodeIfPresent(savedSearchKey, forKey: .savedSearchKey)
        try container.encodeIfPresent(subject, forKey: .subject)
        try container.encodeIfPresent(toEmailList, forKey: .toEmailList)
        try container.encodeIfPresent(dailySchedule, forKey: .dailySchedule)
        try container.encodeIfPresent(languages, forKey: .languages)
        try container.encodeIfPresent(reasonActiveOrDisabled, forKey: .reasonActiveOrDisabled)
        try container.encodeIfPresent(scheduleType, forKey: .scheduleType)
        try container.encodeIfPresent(lastNewChangedTimestamp, forKey: .lastNewChangedTimestamp)
        try container.encodeIfPresent(lastViewedTimestamp, forKey: .lastViewedTimestamp)
        try container.encodeIfPresent(modificationTimestamp, forKey: .modificationTimestamp)
        try container.encodeIfPresent(nextSendTimestamp, forKey: .nextSendTimestamp)
        try container.encodeIfPresent(contact, forKey: .contact)
        try container.encodeIfPresent(ownerMember, forKey: .ownerMember)
        try container.encodeIfPresent(savedSearch, forKey: .savedSearch)
    }
}

